/*	file: 	passcrypt.c
	author:	David Vogler <david@vogler.com>
		Oliver Boehm <boehm@2xp.de>
	date:	22-Apr-2002
	desc:	encrypts password, see 'man 3 crypt' for details
*/

#define _XOPEN_SOURCE
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>

static char* shuffleSalt(void);
static char  shuffleChar(void);

int main(int argc, char *argv[]) {

    char *crypted = "failed";
    char *key  = NULL;
    char *salt = NULL;

    switch(argc) {
        case 2:
	    key  = argv[1];
	    salt = shuffleSalt();
	    break;
        case 3:
	    key  = argv[1];
	    salt = argv[2];
	    break;
        default:
	    fprintf(stderr, "usage: %s key [salt]\n", argv[0]);
	    exit(1);
	    break;
    }
    crypted = crypt(key, salt);
    printf("%s\n", crypted);
    return 0;
}

static char* shuffleSalt() {
    static char salt[3];

    srand(time(0));	/* initialize random generator */
    salt[0] = shuffleChar();
    salt[1] = shuffleChar();
    salt[2] = '\0';
    return salt;
}

static char shuffleChar() {
    char charset[] = "abcdefghijklmnopqrstuvwxyz"
	             "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
	             "0123456789./";

    int i = rand() % sizeof(charset);
    return charset[i];
}
